
typedef  unsigned char byte ;
#pragma optsize+

#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

unsigned char bcd2bin(unsigned char n);
unsigned char bin2bcd(unsigned char n);

#pragma used-

#pragma library bcd.lib

byte  Dig[13],
ind [8],  

i   ,     

number_razr [8] ,  

ustan_pinow [8];   

void Dig_init()
{ 

Dig[0] = (32+128+2+8               +16+64);   
Dig[1] = (128+2);
Dig[2] = (32+128+1+16+8               );
Dig[3] = (32+128+1+2+8               );
Dig[4] = (64+1+128+2);
Dig[5] = (32+64+1+2+8               );
Dig[6] = (32+64+1+2+8               +16);
Dig[7] = (32+128+2);
Dig[8] = (32+128+2+8               +16+64+1);
Dig[9] = (32+128+2+8               +64+1);
Dig[10] = (1);
Dig[11] = (32+128+64+1);
Dig[12]=  0;

number_razr [0]  = ~16;
number_razr [1]  = ~1;
number_razr [2]  = ~2;     
number_razr [3]  = ~32;
number_razr [4]  = 16 ;    
number_razr [5]  = 1   ;
number_razr [6]  = 2   ;
number_razr [7]  = 32;

ustan_pinow [0]=16;
ustan_pinow [1]=1;
ustan_pinow [2]=2;
ustan_pinow [3]=32;       
ustan_pinow [4]=16;
ustan_pinow [5]=1;
ustan_pinow [6]=2;
ustan_pinow [7]=32;

}

interrupt [7] void timer0_ovf_isr(void)
{ 

TCNT0=0xF7;
DDRB=255;
if (i< 4)
{
PORTB=ind[i];   
}

else 
{
PORTB=~ind[i];   
}

DDRD= ustan_pinow [i];
PORTD= number_razr [i] & 0b00110011 ; 

i++ ;                    
if (i>7) i=0;          

}

#asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=6
 #endasm

#pragma used+
unsigned char w1_init(void);
unsigned char w1_read(void);
unsigned char w1_write(unsigned char data);
unsigned char w1_search(unsigned char cmd,void *p);
unsigned char w1_dow_crc8(void *p,unsigned char n);
#pragma used-

#pragma used+

extern struct __ds18x20_scratch_pad_struct
{
unsigned char temp_lsb,temp_msb,
temp_high,temp_low,
conf_register,
x1,
x2,
x3,
crc;
} __ds18x20_scratch_pad;

unsigned char ds18x20_select(unsigned char *addr);
unsigned char ds18x20_read_spd(unsigned char *addr);

int ds18s20_temperature(unsigned char *addr);

int ds18b20_temperature(unsigned char *addr);

#pragma used-

#pragma library ds18x20_v2.lib

byte ds18b20_devices;

byte ds18b20_rom_codes[2][9];

void main(void)             
{

unsigned int temp[2];

byte n , tempb, initResult, sign[2] ; 

Dig_init();

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+

TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0xF7;
OCR0A=0x00;
OCR0B=0x00;

TIMSK=0x02;

initResult =0;

while (1)   
{ 
if 
( initResult  !=0 )

{    

delay_ms (10000);  

for(n=0; n < ds18b20_devices; n++) 
{  

#asm("cli")                                                                     
temp[n]=ds18b20_temperature(&ds18b20_rom_codes[n][0]) ;
#asm("sei")

} 

for (n=0; n < ds18b20_devices; n++) 
{                             

if (temp[n]==0x1000) 
{ 
temp[n]=0; 

if (n==0) 
{    

ind[3]=Dig[12];
ind[2]=Dig[12];                        
ind[1]=Dig[0];

}
else
{                                                   

ind[7]=Dig[12];
ind[6]=Dig[12];
ind[5]=Dig[0];                              
}
}                                          
else 

{

sign[n]=0;

if (temp[n] > 0x1000)

{                                 
temp[n] =4096-temp[n]; 
sign[n]=1;           

} 

else
{
if (n==0)
{
ind[2]=Dig[12];
ind[3]=Dig[12];
}

else 
{
ind[6]=Dig[12];
ind[7]=Dig[12];
}  

}

if ((temp[n] & 0x000F) >= 0x0008)
temp[n] = (temp[n] >> 4) + 1;
else                                        
temp[n] = (temp[n] >> 4);

tempb = bin2bcd((char) temp[n]);

if (n == 0)   
{         
ind[1] = Dig[(tempb & 0x0F)];

if ((tempb >> 4) == 0)

{
if
(sign[n]==1)
ind[2]=Dig[10];
else   
ind[2]=Dig[12];
}

else 

{             
ind[2]=Dig[(tempb >> 4)];

if (sign[n]==1)
ind[3]=Dig[10];
else
ind[3]=Dig[12];
}           

} 

else

{

ind[5] = Dig[(tempb & 0x0F)];

if ((tempb >> 4) == 0)

{
if 
(sign[n]==1)
ind[6]=Dig[10];
else 
ind[6]=Dig[12];
}       

else 

{             
ind[6]=Dig[(tempb >> 4)]; 

if 

(sign[n]==1)
ind[7]=Dig[10];
else 

ind[7]=Dig[12];

}     
}
} 

}

}
else 
{
DDRB=0;
#asm("cli")

initResult = w1_init(); 

ds18b20_devices=w1_search(0xf0,ds18b20_rom_codes);

#asm("sei")
ind[1]=Dig[ds18b20_devices];
ind[0]=Dig[11];
ind[7]=Dig[12];
ind[2]= Dig[initResult];
ind[4]=Dig[11];

}

}
}
